Imports system.text.regularexpressions

Public Class Form1
    'This code is under GPL.
    'You can edit and distribute on any purpose.
    '
    'First writer of this code-> JA7TDO ja7tdo@zao.jp 2007.11.15
    'Please add your sign bellow.
    '
    'AD9834 + FT245RL
    '
    'setting frequency is saved now. 2008.12.30 by JA7TDO
    '
    '
    '
    '
    '
    '
    '
    '






    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ftstatus = FT_ListDevices(numDevs, "", FT_LIST_NUMBER_ONLY)
        If numDevs > 0 Then
            ftstatus = Open_USB_Device_By_Serial_Number(My_serial)
        Else
            ftstatus = FT_Open(0, lngHandle)
        End If
        ftstatus = FT_SetBitMode(lngHandle, &H7, 1)
        ftstatus = FT_SetBaudRate(lngHandle, 30000)


        Frequency.Text = My.Settings.f0

        f0 = Frequency.Text
        Frequency.Text = Format(f0, "##.#####0")

        If ftstatus <> FT_OK Then
            LoggerList = "Open Failed status=" & ftstatus
            echo.Text = LoggerList
            write.Enabled = False
            Exit Sub
        Else
            echo.Text = "Success!" & numDevs & FT_LIST_NUMBER_ONLY & FT_OPEN_BY_SERIAL_NUMBER
            write.Enabled = True
        End If

        ftstatus = FT_Close(lngHandle)


    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles write.Click
        SetFrequency(Val(Trim(Frequency.Text)))
        echo.Text = SendText
    End Sub
    Private Sub Form1_Close(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ftstatus = FT_Close(lngHandle)
        My.Settings.f0 = Val(Frequency.Text)
        My.Settings.MCLK = NumericUpDown2.Value
        My.Settings.delta_f = NumericUpDown1.Value
        My.Settings.Save()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click

        Close()

    End Sub

    Private Sub Form1_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Activated

        Frequency.Select()

    End Sub
    Private Sub Frequency_MouseWheel(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Frequency.MouseWheel
        'wheel control
        Dim i As Integer
        Dim SendData As String = ""

        WheelValue = e.Delta

        If WheelValue > 1 Then
            i = delta_f
        ElseIf WheelValue < -1 Then
            i = delta_f * -1
        End If

        If Val(Frequency.Text) >= MCLK / 2000000 Then
            Frequency.Text = MCLK / 2000000 - 0.001
        End If

        If Val(Frequency.Text) < 0.001 Then
            Frequency.Text = 0.001
        End If

        Frequency.Text = Val(Frequency.Text) + (i / 1000)
        Frequency.Text = Format(Val(Frequency.Text), "##.#####0")
        lngBytesWritten = 0

        SetFrequency(Val(Frequency.Text))

        echo.Text = SendText
        RichTextBox1.Text = Val(Frequency.Text)
        My.Settings.f0 = Val(Frequency.Text)
        ' My.Settings.Save()


    End Sub

    Private Sub NumericUpDown1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDown1.ValueChanged
        delta_f = NumericUpDown1.Value
    End Sub

    Private Sub NumericUpDown2_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDown2.ValueChanged

        MCLK = NumericUpDown2.Value * 1000000
        If MCLK < 5000000 Then
            MCLK = 50000000
        End If

        RichTextBox1.Text = NumericUpDown2.Value
    End Sub


    Private Sub Frequency_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Frequency.TextChanged
        If Regex.IsMatch(Frequency.Text, "[0-9.]") = False Then
            Beep()
            echo.Text = "error please input 0-9"
        End If
        Frequency.Focus()

    End Sub

    Private Sub RichTextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RichTextBox1.TextChanged

    End Sub
End Class
